/*
 * OSM NB API featuring ETSI NFV SOL005
 * This is Open Source MANO Northbound API featuring ETSI NFV SOL005. For more information on OSM, you can visit [http://osm.etsi.org](http://osm.etsi.org). You can send us your comments and questions to OSM_TECH@list.etsi.org or join the [OpenSourceMANO Slack Workplace](https://join.slack.com/t/opensourcemano/shared_invite/enQtMzQ3MzYzNTQ0NDIyLWVkNTE4ZjZjNWI0ZTQyN2VhOTI1MjViMzU1NWYwMWM3ODI4NTQyY2VlODA2ZjczMWIyYTFkZWNiZmFkM2M2ZDk) 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: OSM_TECH@list.etsi.org
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.lcm.nfvo.osm.rest.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.v3.oas.annotations.media.Schema;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * InstantiateNsRequestProvidernetwork
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2022-03-04T13:48:18.253Z[GMT]")
public class InstantiateNsRequestProvidernetwork {
  @SerializedName("physical-network")
  private String physicalNetwork = null;

  @SerializedName("segmentation-id")
  private String segmentationId = null;

  @SerializedName("network-type")
  private String networkType = null;

  @SerializedName("sdn-ports")
  private List<Map> sdnPorts = null;

  public InstantiateNsRequestProvidernetwork physicalNetwork(String physicalNetwork) {
    this.physicalNetwork = physicalNetwork;
    return this;
  }

   /**
   * Get physicalNetwork
   * @return physicalNetwork
  **/
  @Schema(description = "")
  public String getPhysicalNetwork() {
    return physicalNetwork;
  }

  public void setPhysicalNetwork(String physicalNetwork) {
    this.physicalNetwork = physicalNetwork;
  }

  public InstantiateNsRequestProvidernetwork segmentationId(String segmentationId) {
    this.segmentationId = segmentationId;
    return this;
  }

   /**
   * Get segmentationId
   * @return segmentationId
  **/
  @Schema(description = "")
  public String getSegmentationId() {
    return segmentationId;
  }

  public void setSegmentationId(String segmentationId) {
    this.segmentationId = segmentationId;
  }

  public InstantiateNsRequestProvidernetwork networkType(String networkType) {
    this.networkType = networkType;
    return this;
  }

   /**
   * Get networkType
   * @return networkType
  **/
  @Schema(description = "")
  public String getNetworkType() {
    return networkType;
  }

  public void setNetworkType(String networkType) {
    this.networkType = networkType;
  }

  public InstantiateNsRequestProvidernetwork sdnPorts(List<Map> sdnPorts) {
    this.sdnPorts = sdnPorts;
    return this;
  }

  public InstantiateNsRequestProvidernetwork addSdnPortsItem(Map sdnPortsItem) {
    if (this.sdnPorts == null) {
      this.sdnPorts = new ArrayList<Map>();
    }
    this.sdnPorts.add(sdnPortsItem);
    return this;
  }

   /**
   * connect additional ports to the created underlay SDN connectivity. Normally for external connectivy. 
   * @return sdnPorts
  **/
  @Schema(description = "connect additional ports to the created underlay SDN connectivity. Normally for external connectivy. ")
  public List<Map> getSdnPorts() {
    return sdnPorts;
  }

  public void setSdnPorts(List<Map> sdnPorts) {
    this.sdnPorts = sdnPorts;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InstantiateNsRequestProvidernetwork instantiateNsRequestProvidernetwork = (InstantiateNsRequestProvidernetwork) o;
    return Objects.equals(this.physicalNetwork, instantiateNsRequestProvidernetwork.physicalNetwork) &&
        Objects.equals(this.segmentationId, instantiateNsRequestProvidernetwork.segmentationId) &&
        Objects.equals(this.networkType, instantiateNsRequestProvidernetwork.networkType) &&
        Objects.equals(this.sdnPorts, instantiateNsRequestProvidernetwork.sdnPorts);
  }

  @Override
  public int hashCode() {
    return Objects.hash(physicalNetwork, segmentationId, networkType, sdnPorts);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InstantiateNsRequestProvidernetwork {\n");
    
    sb.append("    physicalNetwork: ").append(toIndentedString(physicalNetwork)).append("\n");
    sb.append("    segmentationId: ").append(toIndentedString(segmentationId)).append("\n");
    sb.append("    networkType: ").append(toIndentedString(networkType)).append("\n");
    sb.append("    sdnPorts: ").append(toIndentedString(sdnPorts)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
